/*
 * (C)opyright 1993, 1994, 1995 by Darren Reed.
 *
 * This code may be freely distributed as long as it retains this notice
 * and is not changed in any way.  The author accepts no responsibility
 * for the use of this software.  I hate legaleese, don't you ?
 */
#ifndef	lint
static	char	sccsid[] = "%W% %G% (C)1995 Darren Reed";
#endif
#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/param.h>

#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <netinet/tcp.h>
#include <netinet/ip_icmp.h>

#ifndef IPOPT_OLEN
#define IPOPT_OPTVAL	0
#define IPOPT_OLEN	1
#define IPOPT_OFFSET	2
#define IPOPT_MINOFF	4
#endif

#define	PAUSE()	tv.tv_sec = 0; tv.tv_usec = 10000; \
		fflush(stdout); \
		  (void) select(0, NULL, NULL, NULL, &tv)

unsigned short chksum(unsigned short *buf, int len)
{
	unsigned long sum=0;
	int nwords=len>>1;

	for(;nwords>0;nwords--)
		sum += *buf++;

	sum = (sum>>16) + (sum & 0xffff);
	sum += (sum>>16);

	return(~sum);
}

void ip_test1(int sock, unsigned char *packet, int mtu, int ptest)
{
	struct timeval tv;
	struct iphdr *ip=(struct iphdr *)packet;
	struct udphdr *u;
	int i, len, id = getpid();

	ip->ihl = sizeof(*ip) >> 2;
	ip->version = 4;
	ip->tos = 0;
	ip->frag_off = 0;
	ip->ttl = 60;
	ip->protocol = IPPROTO_UDP;
	ip->check = 0;
	u = (struct udphdr *)(ip + 1);
	u->source = 1;
	u->dest = 9;
	u->check = 0;
	u->len = sizeof(*u) + 4;
	ip->tot_len = sizeof(*ip) + u->len;
	len = ip->tot_len;

	u->source = htons(u->source);
	u->dest = htons(u->dest);
	u->len = htons(u->len);
	if (!ptest || (ptest == 1)) {
		/*
		 * Part1: hl < len
		 */
		ip->id = 0;
		printf("1.1. sending packets with ihl < tot_len\n");
		for (i = 0; i < ((sizeof(*ip) + u->len) >> 2); i++) {
			ip->ihl = i >> 2;
			(void) sendip(sock, packet, mtu, 1);
			printf("%d\r", i);
			fflush(stdout);
			PAUSE();
		}
		putchar('\n');
	}

	if (!ptest || (ptest == 2)) {
		/*
		 * Part2: hl > len
		 */
		ip->id = 0;
		printf("1.2. sending packets with ihl > tot_len\n");
		for (; i < ((sizeof(*ip) * 2 + u->len) >> 2); i++) {
			ip->ihl = i >> 2;
			(void) sendip(sock, packet, mtu, 1);
			printf("%d\r", i);
			fflush(stdout);
			PAUSE();
		}
		putchar('\n');
	}

	if (!ptest || (ptest == 3)) {
		/*
		 * Part3: v < 4
		 */
		ip->id = 0;
		printf("1.3. version < 4\n");
		ip->ihl = sizeof(*ip) >> 2;
		for (i = 0; i < 4; i++) {
			ip->version = i;
			(void) sendip(sock, packet, mtu, 1);
			printf("%d\r", i);
			fflush(stdout);
			PAUSE();
		}
		putchar('\n');
	}

	if (!ptest || (ptest == 4)) {
		/*
		 * Part4: v > 4
		 */
		ip->id = 0;
		printf("1.4. version > 4\n");
		for (i = 5; i < 16; i++) {
			ip->version = i;
			(void) sendip(sock, packet, mtu, 1);
			printf("%d\r", i);
			fflush(stdout);
			PAUSE();
		}
		putchar('\n');
	}

	if (!ptest || (ptest == 5)) {
		/*
		 * Part5: len < packet
		 */
		ip->id = 0;
		ip->version = 4;
		i = ip->tot_len + 1;
		ip->tot_len = htons(ip->tot_len);
		ip->frag_off = htons(ip->frag_off);
		printf("1.5.0 tot_len < packet size (size++, long packets)\n");
		for (; i < (ntohs(ip->tot_len) * 2); i++) {
			ip->id = htons(id++);
			ip->check = 0;
			ip->check = chksum((unsigned short *)ip, ip->ihl << 2);
			(void) sendraw(sock, packet);
			printf("%d\r", i);
			fflush(stdout);
			PAUSE();
		}
		putchar('\n');
		printf("1.5.1 tot_len < packet size (tot_len-, short packets)\n");
		for (i = len; i > 0; i--) {
			ip->id = htons(id++);
			ip->tot_len = htons(i);
			ip->check = 0;
			ip->check = chksum((unsigned short *)ip, ip->ihl << 2);
			(void) sendraw(sock, packet);
			printf("%d\r", i);
			fflush(stdout);
			PAUSE();
		}
		putchar('\n');
	}

	if (!ptest || (ptest == 6)) {
		/*
		 * Part6: len > packet
		 */
		ip->id = 0;
		printf("1.6.0 tot_len > packet size (increase tot_len)\n");
		for (i = len + 1; i < (len * 2); i++) {
			ip->id = htons(id++);
			ip->tot_len = htons(i);
			ip->check = 0;
			ip->check = chksum((unsigned short *)ip, ip->ihl << 2);
			(void) sendraw(sock, packet);
			printf("%d\r", i);
			fflush(stdout);
			PAUSE();
		}
		putchar('\n');
		ip->tot_len = htons(len);
		printf("1.6.1 tot_len > packet size (size--, short packets)\n");
		for (i = len; i > 0; i--) {
			ip->id = htons(id++);
			ip->check = 0;
			ip->check = chksum((unsigned short *)ip, ip->ihl << 2);
			(void) sendraw(sock, packet);
			printf("%d\r", i);
			fflush(stdout);
			PAUSE();
		}
		putchar('\n');
	}

	if (!ptest || (ptest == 7)) {
		/*
		 * Part7: 0 length fragment
		 */
		printf("1.7.0 Zero length fragments (frag_off = 0x2000)\n");
		ip->id = 0;
		ip->tot_len = sizeof(*ip);
		ip->frag_off = 0x2000;
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();

		printf("1.7.1 Zero length fragments (frag_off = 0x3000)\n");
		ip->id = 0;
		ip->tot_len = sizeof(*ip);
		ip->frag_off = 0x3000;
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();

		printf("1.7.2 Zero length fragments (frag_off = 0xa000)\n");
		ip->id = 0;
		ip->tot_len = sizeof(*ip);
		ip->frag_off = 0xa000;
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();

		printf("1.7.3 Zero length fragments (frag_off = 0x0100)\n");
		ip->id = 0;
		ip->tot_len = sizeof(*ip);
		ip->frag_off = 0x0100;
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();
	}

	if (!ptest || (ptest == 8)) {
		struct	timeval	tv;

		gettimeofday(&tv, NULL);
		srand(tv.tv_sec ^ getpid() ^ tv.tv_usec);
		/*
		 * Part8: 63k packet + 1k fragment at offset 0x1ffe
		 * Mark it as being ICMP (so it doesn't get junked), but
		 * don't bother about the ICMP header, we're not worrying
		 * about that here.
		 */
		ip->protocol = IPPROTO_ICMP;
		ip->frag_off = 0x2000;
		u->dest = htons(9);
		ip->id = htons(id++);
		printf("1.8. 63k packet + 1k fragment at offset 0x1ffe\n");
		ip->tot_len = 768 + 20 + 8;
		if ((rand() & 0x1f) != 0) {
			(void) sendip(sock, packet, mtu, 1);
			printf("%d\r", i);
		} else
			printf("skip 0\n");

		ip->tot_len = 768 + 20>mtu - 68?mtu-68:768+20;
		i = 512;
		for (; i < (63 * 1024 + 768); i += 768) {
			ip->frag_off = 0x2000 | (i >> 3);
			if ((rand() & 0x1f) != 0) {
				(void) sendip(sock, packet, mtu, 1);
				printf("%d\r", i);
			} else
				printf("skip %d\n", i);
			fflush(stdout);
			PAUSE();
		}
		ip->tot_len = 896 + 20;
		ip->frag_off = 0x2000 | (i >> 3);
		if ((rand() & 0x1f) != 0) {
			(void) sendip(sock, packet, mtu, 1);
			printf("%d\r", i);
		} else
			printf("skip\n");
		putchar('\n');
		fflush(stdout);
	}

	ip->tot_len = len;
	ip->frag_off = 0;
	if (!ptest || (ptest == 9)) {
		/*
		 * Part9: off & 0x8000 == 0x8000
		 */
		ip->id = 0;
		ip->frag_off = 0x8000;
		printf("1.9. frag_off & 0x8000 == 0x8000\n");
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();
	}

	ip->frag_off = 0;

	if (!ptest || (ptest == 10)) {
		/*
		 * Part10: ttl = 255
		 */
		ip->id = 0;
		ip->ttl = 255;
		printf("1.10.0 ttl = 255\n");
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();

		ip->ttl = 128;
		printf("1.10.1 ttl = 128\n");
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();

		ip->ttl = 0;
		printf("1.10.2 ttl = 0\n");
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();
	}
}


void ip_test2(int sock, unsigned char *packet, int mtu, int ptest)
{
	struct timeval tv;
	struct iphdr *ip=(struct iphdr *)packet;
	struct udphdr *u;
	int i, len, id = getpid();
	u_char *s;

	s = (unsigned char *)(ip + 1);

	ip->ihl = 6;
	ip->tot_len = ip->ihl << 2;
	s[IPOPT_OPTVAL] = IPOPT_NOOP;
	s++;
	if (!ptest || (ptest == 1)) {
		/*
		 * Test 1: option length > packet length,
		 *                header length == packet length
		 */
		s[IPOPT_OPTVAL] = IPOPT_TIMESTAMP;
		s[IPOPT_OLEN] = 4;
		s[IPOPT_OFFSET] = IPOPT_MINOFF;
		ip->protocol = IPPROTO_IP;
		printf("2.1 option length > packet length\n");
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();
	}

	ip->ihl = 7;
	ip->tot_len = ip->ihl << 2;
	if (!ptest || (ptest == 1)) {
		/*
		 * Test 2: options have length = 0
		 */
		printf("2.2.1 option length = 0, RR\n");
		s[IPOPT_OPTVAL] = IPOPT_RR;
		s[IPOPT_OLEN] = 0;
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();

		printf("2.2.2 option length = 0, TS\n");
		s[IPOPT_OPTVAL] = IPOPT_TIMESTAMP;
		s[IPOPT_OLEN] = 0;
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();

		printf("2.2.3 option length = 0, SEC\n");
		s[IPOPT_OPTVAL] = IPOPT_SEC;
		s[IPOPT_OLEN] = 0;
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();

		printf("2.2.4 option length = 0, LSRR\n");
		s[IPOPT_OPTVAL] = IPOPT_LSRR;
		s[IPOPT_OLEN] = 0;
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();

		printf("2.2.5 option length = 0, SID\n");
		s[IPOPT_OPTVAL] = IPOPT_SID;
		s[IPOPT_OLEN] = 0;
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();

		printf("2.2.6 option length = 0, SSRR\n");
		s[IPOPT_OPTVAL] = IPOPT_SSRR;
		s[IPOPT_OLEN] = 0;
		(void) sendip(sock, packet, mtu, 1);
		fflush(stdout);
		PAUSE();
	}
}


/*
 * test 3 (ICMP)
 */
void ip_test3(int sock, unsigned char *packet, int mtu, int ptest)
{
	struct iphdr *ip=(struct iphdr *)packet;
	static int ict1[10] = { 8, 9, 10, 13, 14, 15, 16, 17, 18, 0 };
	static int ict2[8] = { 3, 9, 10, 13, 14, 17, 18, 0 };
	struct timeval tv;
	struct icmphdr *icp;
	int i, len, id = getpid();
	u_char *s;

	ip->ihl = sizeof(*ip) >> 2;
	ip->version = 4;
	ip->tos = 0;
	ip->frag_off = 0;
	ip->ttl = 60;
	ip->protocol = IPPROTO_ICMP;
	ip->check = 0;
	ip->tot_len = sizeof(*ip) + sizeof(*icp);
	icp = (struct icmphdr *)((char *)ip + (ip->ihl << 2));

	if (!ptest || (ptest == 1)) {
		/*
		 * Type 0 - 31, 255, code = 0
		 */
		bzero((char *)icp, sizeof(*icp));
		for (i = 0; i < 32; i++) {
			icp->type = i;
			(void) sendicmp(sock, packet, mtu);
			PAUSE();
			printf("3.1.%d ICMP type %d code 0 (all 0's)\r", i, i);
		}
		icp->type = 255;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.1.%d ICMP type %d code 0 (all 0's)\r", i, 255);
		putchar('\n');
	}

	if (!ptest || (ptest == 2)) {
		/*
		 * Type 3, code = 0 - 31
		 */
		icp->type = 3;
		for (i = 0; i < 32; i++) {
			icp->code = i;
			(void) sendicmp(sock, packet, mtu);
			PAUSE();
			printf("3.2.%d ICMP type 3 code %d (all 0's)\r", i, i);
		}
		putchar('\n');
	}

	if (!ptest || (ptest == 3)) {
		/*
		 * Type 4, code = 0,127,128,255
		 */
		icp->type = 4;
		icp->code = 0;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.3.1 ICMP type 4 code 0 (all 0's)\r");
		icp->code = 127;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.3.2 ICMP type 4 code 127 (all 0's)\r");
		icp->code = 128;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.3.3 ICMP type 4 code 128 (all 0's)\r");
		icp->code = 255;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.3.4 ICMP type 4 code 255 (all 0's)\r");
		putchar('\n');
	}

	if (!ptest || (ptest == 4)) {
		/*
		 * Type 5, code = 0,127,128,255
		 */
		icp->type = 5;
		icp->code = 0;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.4.1 ICMP type 5 code 0 (all 0's)\r");
		icp->code = 127;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.4.2 ICMP type 5 code 127 (all 0's)\r");
		icp->code = 128;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.4.3 ICMP type 5 code 128 (all 0's)\r");
		icp->code = 255;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.4.4 ICMP type 5 code 255 (all 0's)\r");
		putchar('\n');
	}

	if (!ptest || (ptest == 5)) {
		/*
		 * Type 8-10;13-18, code - 0,127,128,255
		 */
		for (i = 0; ict1[i]; i++) {
			icp->type = ict1[i];
			icp->code = 0;
			(void) sendicmp(sock, packet, mtu);
			PAUSE();
			printf("3.5.%d ICMP type 5 code 0 (all 0's)\r",
				i * 4);
			icp->code = 127;
			(void) sendicmp(sock, packet, mtu);
			PAUSE();
			printf("3.5.%d ICMP type 5 code 127 (all 0's)\r",
				i * 4 + 1);
			icp->code = 128;
			(void) sendicmp(sock, packet, mtu);
			PAUSE();
			printf("3.5.%d ICMP type 5 code 128 (all 0's)\r",
				i * 4 + 2);
			icp->code = 255;
			(void) sendicmp(sock, packet, mtu);
			PAUSE();
			printf("3.5.%d ICMP type 5 code 255 (all 0's)\r",
				i * 4 + 3);
		}
		putchar('\n');
	}

	if (!ptest || (ptest == 6)) {
		/*
		 * Type 12, code - 0,127,128,129,255
		 */
		icp->type = 12;
		icp->code = 0;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.6.1 ICMP type 12 code 0 (all 0's)\r");
		icp->code = 127;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.6.2 ICMP type 12 code 127 (all 0's)\r");
		icp->code = 128;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.6.3 ICMP type 12 code 128 (all 0's)\r");
		icp->code = 129;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.6.4 ICMP type 12 code 129 (all 0's)\r");
		icp->code = 255;
		(void) sendicmp(sock, packet, mtu);
		PAUSE();
		printf("3.6.5 ICMP type 12 code 255 (all 0's)\r");
		putchar('\n');
	}

	if (!ptest || (ptest == 7)) {
		/*
		 * Type 3;9-10;13-14;17-18 - shorter packets
		 */
		ip->tot_len = sizeof(*ip) + sizeof(*icp) / 2;
		for (i = 0; ict2[i]; i++) {
			icp->type = ict1[i];
			icp->code = 0;
			(void) sendicmp(sock, packet, mtu);
			PAUSE();
			printf("3.7.%d ICMP type %d code 0 (all 0's)\r",
				i * 4, icp->type);
			icp->code = 127;
			(void) sendicmp(sock, packet, mtu);
			PAUSE();
			printf("3.7.%d ICMP type %d code 127 (all 0's)\r",
				i * 4 + 1, icp->type);
			icp->code = 128;
			(void) sendicmp(sock, packet, mtu);
			PAUSE();
			printf("3.7.%d ICMP type %d code 128 (all 0's)\r",
				i * 4 + 2, icp->type);
			icp->code = 255;
			(void) sendicmp(sock, packet, mtu);
			PAUSE();
			printf("3.7.%d ICMP type %d code 127 (all 0's)\r",
				i * 4 + 3, icp->type);
		}
		putchar('\n');
	}
}


/* Perform test 4 (UDP) */

void ip_test4(int sock, unsigned char *packet, int mtu, int ptest)
{
	struct iphdr *ip=(struct iphdr *)packet;
	struct timeval tv;
	struct udphdr *u;
	int i, len, id = getpid();


	ip->ihl = sizeof(*ip) >> 2;
	ip->version = 4;
	ip->tos = 0;
	ip->frag_off = 0;
	ip->ttl = 60;
	ip->protocol = IPPROTO_UDP;
	ip->check = 0;
	u = (struct udphdr *)((char *)ip + (ip->ihl << 2));
	u->source = 1;
	u->dest = 1;
	u->len = sizeof(*u) + 4;

	if (!ptest || (ptest == 1)) {
		/*
		 * Test 1. ulen > packet
		 */
		u->len = sizeof(*u) + 4;
		ip->tot_len = (ip->ihl << 2) + u->len;
		printf("4.1 UDP len > packet size - short packets\n");
		for (i = u->len * 2; i > sizeof(*u) + 4; i--) {
			u->len = i;
			(void) sendudp(sock, packet, mtu);
			printf("%d\r", i);
			fflush(stdout);
			PAUSE();
		}
		putchar('\n');
	}

	if (!ptest || (ptest == 2)) {
		/*
		 * Test 2. ulen < packet
		 */
		u->len = sizeof(*u) + 4;
		ip->tot_len = (ip->ihl << 2) + u->len;
		printf("4.2 UDP len < packet size - short packets\n");
		for (i = u->len * 2; i > sizeof(*u) + 4; i--) {
			ip->tot_len = i;
			(void) sendudp(sock, packet, mtu);
			printf("%d\r", i);
			fflush(stdout);
			PAUSE();
		}
		putchar('\n');
	}

	if (!ptest || (ptest == 3)) {
		/*
		 * Test 3: sport = 0, sport = 1, sport = 32767
		 *         sport = 32768, sport = 65535
		 */
		u->len = sizeof(*u) + 4;
		ip->tot_len = (ip->ihl << 2) + u->len;
		printf("4.3.1 UDP sport = 0\n");
		u->source = 0;
		(void) sendudp(sock, packet, mtu);
		printf("0\n");
		fflush(stdout);
		PAUSE();
		printf("4.3.2 UDP sport = 1\n");
		u->source = 1;
		(void) sendudp(sock, packet, mtu);
		printf("1\n");
		fflush(stdout);
		PAUSE();
		printf("4.3.3 UDP sport = 32767\n");
		u->source = 32767;
		(void) sendudp(sock, packet, mtu);
		printf("32767\n");
		fflush(stdout);
		PAUSE();
		printf("4.3.4 UDP sport = 32768\n");
		u->source = 32768;
		(void) sendudp(sock, packet, mtu);
		printf("32768\n");
		fflush(stdout);
		PAUSE();
		printf("4.3.5 UDP sport = 65535\n");
		u->source = 65535;
		(void) sendudp(sock, packet, mtu);
		printf("65535\n");
		fflush(stdout);
		PAUSE();
	}

	if (!ptest || (ptest == 4)) {
		/*
		 * Test 4: dport = 0, dport = 1, dport = 32767
		 *         dport = 32768, dport = 65535
		 */
		u->len = sizeof(*u) + 4;
		u->source = 1;
		ip->tot_len = (ip->ihl << 2) + u->len;
		printf("4.4.1 UDP dport = 0\n");
		u->dest = 0;
		(void) sendudp(sock, packet, mtu);
		printf("0\n");
		fflush(stdout);
		PAUSE();
		printf("4.4.2 UDP dport = 1\n");
		u->dest = 1;
		(void) sendudp(sock, packet, mtu);
		printf("1\n");
		fflush(stdout);
		PAUSE();
		printf("4.4.3 UDP dport = 32767\n");
		u->dest = 32767;
		(void) sendudp(sock, packet, mtu);
		printf("32767\n");
		fflush(stdout);
		PAUSE();
		printf("4.4.4 UDP dport = 32768\n");
		u->dest = 32768;
		(void) sendudp(sock, packet, mtu);
		printf("32768\n");
		fflush(stdout);
		PAUSE();
		printf("4.4.5 UDP dport = 65535\n");
		u->dest = 65535;
		(void) sendudp(sock, packet, mtu);
		printf("65535\n");
		fflush(stdout);
		PAUSE();
	}

	if (!ptest || (ptest == 5)) {
		/*
		 * Test 5: sizeof(struct ip) <= MTU <= sizeof(struct udphdr) +
		 * sizeof(struct ip)
		 */
		printf("4.5 UDP 20 <= MTU <= 32\n");
		for (i = sizeof(*ip); i <= 32 /*u->len*/; i++) {
			(void) sendudp(sock, packet, i);
			printf("%d\r", i);
			fflush(stdout);
			PAUSE();
		}
		putchar('\n');
	}
}


/* Perform test 5 (TCP) */

void ip_test5(int sock, unsigned char *packet, int mtu, int ptest)
{
	struct iphdr *ip=(struct iphdr *)packet;
	struct tcphdr *t;
	struct timeval tv;
	int i, len, id = getpid();

	t = (struct tcphdr *)((char *)ip + (ip->ihl << 2));
	t->th_off = 0;
	t->th_sport = 1;
	t->th_dport = 1;
	t->th_win = 4096;
	t->th_urp = 0;
	t->th_sum = 0;
	t->th_seq = 1;
	t->th_ack = 0;

	if (!ptest || (ptest == 1)) {
		/*
		 * Test 1: flags variations, 0 - 3f
		 */
		t->th_off = sizeof(*t) >> 2;
		printf("5.1 Test TCP flag combinations\n");
		for (i = 0; i <= (TH_URG|TH_ACK|TH_PUSH|TH_RST|TH_SYN|TH_FIN);
		     i++) {
			t->th_flags=i;
			(void) sendtcp(sock, packet, mtu);
			printf("%d\r", i);
			fflush(stdout);
			PAUSE();
		}
		putchar('\n');
	}

	if (!ptest || (ptest == 2)) {
		t->th_flags = TH_SYN;
		/*
		 * Test 2: seq = 0, seq = 1, seq = 0x7fffffff, seq=0x80000000,
		 *         seq = 0xa000000, seq = 0xffffffff
		 */
		printf("5.2.1 TCP seq = 0\n");
		t->th_seq = 0;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.2.2 TCP seq = 1\n");
		t->th_seq = 1;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.2.3 TCP seq = 0x7fffffff\n");
		t->th_seq = 0x7fffffff;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.2.4 TCP seq = 0x80000000\n");
		t->th_seq = 0x80000000;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.2.5 TCP seq = 0xc0000000\n");
		t->th_seq = 0xc0000000;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.2.6 TCP seq = 0xffffffff\n");
		t->th_seq = 0xffffffff;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();
	}

	if (!ptest || (ptest == 3)) {
		t->th_flags = TH_ACK;
		/*
		 * Test 3: ack = 0, ack = 1, ack = 0x7fffffff, ack = 0x8000000
		 *         ack = 0xa000000, ack = 0xffffffff
		 */
		printf("5.3.1 TCP ack = 0\n");
		t->th_ack = 0;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.3.2 TCP ack = 1\n");
		t->th_ack = 1;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.3.3 TCP ack = 0x7fffffff\n");
		t->th_ack = 0x7fffffff;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.3.4 TCP ack = 0x80000000\n");
		t->th_ack = 0x80000000;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.3.5 TCP ack = 0xc0000000\n");
		t->th_ack = 0xc0000000;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.3.6 TCP ack = 0xffffffff\n");
		t->th_ack = 0xffffffff;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();
	}

	if (!ptest || (ptest == 4)) {
		t->th_flags = TH_SYN;
		/*
		 * Test 4: win = 0, win = 32768, win = 65535
		 */
		printf("5.4.1 TCP win = 0\n");
		t->th_seq = 0;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.4.2 TCP win = 32768\n");
		t->th_seq = 0x7fff;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.4.3 TCP win = 65535\n");
		t->th_win = 0xffff;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();
	}

	t->th_seq = 1;
	t->th_ack = 1;

	if (!ptest || (ptest == 7)) {
		t->th_off = 0;
		t->th_flags = TH_SYN;
		/*
		 * Test 7: sport = 0, sport = 1, sport = 32767
		 *         sport = 32768, sport = 65535
		 */
		printf("5.7.1 TCP sport = 0\n");
		t->th_sport = 0;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.7.2 TCP sport = 1\n");
		t->th_sport = 1;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.7.3 TCP sport = 32767\n");
		t->th_sport = 32767;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.7.4 TCP sport = 32768\n");
		t->th_sport = 32768;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.7.5 TCP sport = 65535\n");
		t->th_sport = 65535;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();
		
		printf("5.7.6 TCP 0 length option party trick\n");
		t->th_off=(4+sizeof(*t))>>2;	/* One long word */
		{
			char *ptr=(char *)(t+1);
			*ptr++=TCPOPT_MAXSEG;
			*ptr++=0;
			*ptr++=0;
			*ptr++=0;
		}
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();
	}

	if (!ptest || (ptest == 8)) {
		t->th_sport = 1;
		/*
		 * Test 8: dport = 0, dport = 1, dport = 32767
		 *         dport = 32768, dport = 65535
		 */
		printf("5.8.1 TCP dport = 0\n");
		t->th_dport = 0;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.8.2 TCP dport = 1\n");
		t->th_dport = 1;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.8.3 TCP dport = 32767\n");
		t->th_dport = 32767;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.8.4 TCP dport = 32768\n");
		t->th_dport = 32768;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();

		printf("5.8.5 TCP dport = 65535\n");
		t->th_dport = 65535;
		(void) sendtcp(sock, packet, mtu);
		fflush(stdout);
		PAUSE();
	}
}


/* Perform test 6 (exhaust mbuf test) */

void ip_test6(int sock, unsigned char *packet, int mtu, int ptest)
{
	struct iphdr *ip=(struct iphdr *)packet;
	struct timeval tv;
	struct udphdr *u;
	int i, j, k, len, id = getpid();

	ip->version = 4;
	ip->tos = 0;
	ip->frag_off = 0;
	ip->ttl = 60;
	ip->protocol = IPPROTO_UDP;
	ip->check = 0;
	u = (struct udphdr *)((char *)ip + (ip->ihl << 2));
	u->source = 1;
	u->dest = 9;
	u->check = 0;

	u->source = htons(u->source);
	u->dest = htons(u->dest);
	u->len = htons(7168);

	for (i = 0; i < 65536; i++) {
		/*
		 * First send the entire packet in 768 byte chunks.
		 */
		ip->tot_len = sizeof(*ip) + 768 + sizeof(*u);
		ip->ihl = sizeof(*ip) >> 2;
		ip->frag_off = 0x2000;
		(void) sendip(sock, packet, mtu, 1);
		printf("%d %d\r", i, 0);
		fflush(stdout);
		PAUSE();
		/*
		 * And again using 128 byte chunks.
		 */
		ip->tot_len = sizeof(*ip) + 128 + sizeof(*u);
		ip->frag_off = 0x2000;
		(void) sendip(sock, packet, mtu, 1);
		printf("%d %d\r", i, 0);
		fflush(stdout);
		PAUSE();

		for (j = 768; j < 3584; j += 768) {
			ip->tot_len = sizeof(*ip) + 768;
			ip->frag_off = 0x2000|(j>>3);
			(void) sendip(sock, packet, mtu, 1);
			printf("%d %d\r", i, j);
			fflush(stdout);
			PAUSE();

			ip->tot_len = sizeof(*ip) + 128;
			for (k = j - 768; k < j; k += 128) {
				ip->frag_off = 0x2000|(k>>3);
				(void) sendip(sock, packet, mtu, 1);
				printf("%d %d\r", i, k);
				fflush(stdout);
				PAUSE();
			}
		}
	}
	putchar('\n');
}


/* Perform test 7 (random packets) */

static	u_long	tbuf[64];

void ip_test7(int sock, unsigned char *packet, int mtu, int ptest)
{
	struct iphdr *ip=(struct iphdr *)packet;
	struct iphdr *pip;
	struct timeval tv;
	int i, j;
	u_char *s;

	pip = (struct iphdr *)tbuf;

	srand(time(NULL) ^ (getpid() * getppid()));

	printf("7. send 1024 random IP packets.\n");

	for (i = 0; i < 512; i++) {
		for (s = (u_char *)pip, j = 0; j < sizeof(tbuf); j++, s++)
			*s = (rand() >> 13) & 0xff;
		pip->version = 4;
		bcopy((char *)&ip->daddr, (char *)&pip->daddr,
		      sizeof(struct in_addr));
		pip->check = 0;
		pip->tot_len &= 0xff;
		(void) sendip(sock, tbuf, mtu, 1);
		printf("%d\r", i);
		fflush(stdout);
		PAUSE();
	}
	putchar('\n');

	for (i = 0; i < 512; i++) {
		for (s = (u_char *)pip, j = 0; j < sizeof(tbuf); j++, s++)
			*s = (rand() >> 13) & 0xff;
		pip->version = 4;
		pip->frag_off &= 0xc000;
		bcopy((char *)&ip->daddr, (char *)&pip->daddr,
		      sizeof(struct in_addr));
		pip->check = 0;
		pip->tot_len &= 0xff;
		(void) sendip(sock, tbuf, mtu, 1);
		printf("%d\r", i);
		fflush(stdout);
		PAUSE();
	}
	putchar('\n');
}

void ip_test8(int sock, unsigned char *packet, int mtu, int ptest)
{
	struct iphdr *ip=(struct iphdr *)packet;

	ip->protocol=IPPROTO_UDP;
	ip->tot_len=20;

	(void) sendip(sock, packet, mtu, 1);
}
